extern "C" {
#include "fmopl.h"
}

#include "fmdrv/sysdeps.h"

#include "timers.hh"
#include "pcm.hh"

#include <stdio.h>
#include <string.h>
#include <alloca.h>

static timer pcmtimer;
static PCM pcm;

#if 0
static FM_OPL *opl;
#else
static int opl;
#endif

#if 0
#define OPLNew(x,r) OPLCreate(OPL_TYPE_WAVESEL, (x), (r))
#else
#define OPLNew(x,r)  YM3812Init(1, (x),(r))
#define OPLResetChip YM3812ResetChip
#define OPLWrite     YM3812Write
#define OPLUpdateOne YM3812UpdateOne
#endif

static void Create()
{
	static bool initialized = false;
	if(!initialized)
	{
		opl = OPLNew(1789772*2, pcm.getrate());
		if(opl < 0)
		{
			fprintf(stderr, "Ouch, can't create OPL\n");
			return;
		}
		initialized = true;
		OPLResetChip(opl);
	}
}

static int oplretval,oplregno;
void Fmdrv_Outportb(unsigned port, unsigned char value)
{
	if(port >= 0x388 && port <= 0x38B)
	{
		Create();
		
		unsigned ind = port-0x388;
		OPLWrite(opl, ind, value);
		
		if(ind & 1)
		{
			if(oplregno == 4)
			{
				if(value == 0x80)oplretval = 0x02;
				else if(value ==0x21)oplretval = 0xC0;
			}
		}
		else
			oplregno = value;
	}
}

unsigned char Fmdrv_Inportb(unsigned port)
{
	if(port >= 0x388 && port <= 0x38B)
	{
		return oplretval;
	}
	return 0;
}

void Fmdrv_Usleep(unsigned usecs)
{
	double nrate = 1.0 / pcm.getrate(); //opl->rate;
	unsigned count = pcmtimer.Advance(nrate, usecs / 1E6);
	
	INT16 *buf = (INT16*)alloca(count * sizeof(*buf));
	memset(buf, 0, sizeof buf);
	
	OPLUpdateOne(opl, buf, count);

	for(unsigned a=0; a<count; ++a)
	{
		pcm.output(buf[a] / 32768.0);
	}
}


/* Looking for main() ?
 * See fmdrv/main.c
 *
 * The emulator has no main().
 * The main() is in fmdrv, which is the program
 * which uses here emulation for testing.
 *
 */
